//+------------------------------------------------------------------+
//|                                             Period_Converter.mq4 |
//|                 Copyright  2005-2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs
#include <WinUser32.mqh>

extern int ExtPeriodMultiplier=3; // new period multiplier factor
int        ExtHandle=-1;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   int    i, start_pos, i_time, time0, last_fpos, periodseconds;
   double d_open, d_low, d_high, d_close, d_volume, last_volume,stlow,sthigh,stopen;   
   string c_symbol_all;
   int    hwnd=0,cnt=0;
//---- History header
   int    version=400;
   string c_copyright;
   string c_symbol="Spread GS";
   string c_symbol_1="GOLD";
   string c_symbol_2="SILVER";
   int    i_period=Period()*ExtPeriodMultiplier;
   int    i_digits=Digits;
   int    i_unused[13];
//----  
   ExtHandle=FileOpenHistory(c_symbol+i_period+".hst", FILE_BIN|FILE_WRITE);
   if(ExtHandle < 0) return(-1);
//---- write history file header
   c_copyright="(C)opyright 2003, MetaQuotes Software Corp.";
   FileWriteInteger(ExtHandle, version, LONG_VALUE);
   FileWriteString(ExtHandle, c_copyright, 64);
   FileWriteString(ExtHandle, c_symbol, 12);
   FileWriteInteger(ExtHandle, i_period, LONG_VALUE);
   FileWriteInteger(ExtHandle, i_digits, LONG_VALUE);
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //timesign
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //last_sync
   FileWriteArray(ExtHandle, i_unused, 0, 13);
//---- write history file
   periodseconds=i_period*60;
   if (iBars(c_symbol_1,0)>iBars(c_symbol_2,0))
      {
       start_pos=iBars(c_symbol_2,0)-3;
       c_symbol_all=c_symbol_2;
      }
      else
         {
          start_pos=iBars(c_symbol_1,0)-3;  
          c_symbol_all=c_symbol_1;
         }       
   d_open=iOpen(c_symbol_1,0,start_pos)/iOpen(c_symbol_2,0,start_pos);
   if(iOpen(c_symbol_1,0,start_pos)/iOpen(c_symbol_2,0,start_pos)>iClose(c_symbol_1,0,start_pos)/iClose(c_symbol_2,0,start_pos))
     {
     d_high=iOpen(c_symbol_1,0,start_pos)/iOpen(c_symbol_2,0,start_pos);
     d_low=iClose(c_symbol_1,0,start_pos)/iClose(c_symbol_2,0,start_pos);
     }
   else
      {
      d_high=iClose(c_symbol_1,0,start_pos)/iClose(c_symbol_2,0,start_pos);
      d_low=iOpen(c_symbol_1,0,start_pos)/iOpen(c_symbol_2,0,start_pos);
      }
   d_volume=iVolume(c_symbol_1,0,start_pos)+iVolume(c_symbol_2,0,start_pos);
   //---- normalize open time
   i_time=iTime(c_symbol_all,0,start_pos)/periodseconds;
   i_time*=periodseconds;
   for(i=start_pos-1;i>=0; i--)
     {
      time0=iTime(c_symbol_all,0,i);
      //---- history may be updated
      if(i==0)
        {
         //---- modify index if history was updated
         if(RefreshRates())
            i=iBarShift(NULL,0,time0);
        }
      //----
      if(time0>=i_time+periodseconds || i==0)
        {
         if(i==0 && time0<i_time+periodseconds)
           {
            d_volume+=iVolume(c_symbol_1,0,0)+iVolume(c_symbol_2,0,0);
            if(iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0)>iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0))
               {
               sthigh=iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0);
               stlow=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
               }
            else
               {
               d_high=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
               stlow=iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0);
               }
            if (stlow<d_low)   d_low=stlow;
            if (sthigh>d_high) d_high=sthigh;
            d_close=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
           }
         last_fpos=FileTell(ExtHandle);
         last_volume=iVolume(c_symbol_1,0,i)+iVolume(c_symbol_2,0,i);
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
         FileFlush(ExtHandle);
         cnt++;
         if(time0>=i_time+periodseconds)
           {
            i_time=time0/periodseconds;
            i_time*=periodseconds;
            if(iOpen(c_symbol_1,0,i)/iOpen(c_symbol_2,0,i)>iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i))
               {
               d_high=iOpen(c_symbol_1,0,i)/iOpen(c_symbol_2,0,i);
               d_low=iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i);
               }
            else
               {
               d_high=iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i);
               d_low=iOpen(c_symbol_1,0,i)/iOpen(c_symbol_2,0,i);
               }
            d_open=iOpen(c_symbol_1,0,i)/iOpen(c_symbol_2,0,i);
            d_close=iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i);
            d_volume=last_volume;
           }
        }
       else
        {
         d_volume+=iVolume(c_symbol_1,0,i)+iVolume(c_symbol_2,0,i);
         if(iOpen(c_symbol_1,0,i)/iOpen(c_symbol_2,0,i)>iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i))
               {
               sthigh=iOpen(c_symbol_1,0,i)/iOpen(c_symbol_2,0,i);
               stlow=iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i);
               }
            else
               {
               sthigh=iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i);
               stlow=iOpen(c_symbol_1,0,i)/iOpen(c_symbol_2,0,i);
               }
         if (stlow<d_low)   d_low=stlow;
         if (sthigh>d_high) d_high=sthigh;
         d_close=iClose(c_symbol_1,0,i)/iClose(c_symbol_2,0,i);
        }
     } 
   FileFlush(ExtHandle);
   Print(cnt," record(s) written");
//---- collect incoming ticks
   int last_time=LocalTime()-5;
   while(IsStopped()==false)
     {
      int cur_time=LocalTime();
      //---- check for new rates
      if(RefreshRates())
        {
         time0=iTime(c_symbol_all,0,0);
         FileSeek(ExtHandle,last_fpos,SEEK_SET);
         //---- is there current bar?
         if(time0<i_time+periodseconds)
           {
            d_volume+=iVolume(c_symbol_1,0,0)+iVolume(c_symbol_2,0,0)-last_volume;
            last_volume=iVolume(c_symbol_1,0,0)+iVolume(c_symbol_2,0,0);
            if(iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0)>iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0))
               {
               sthigh=iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0);
               stlow=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
               }
            else
               {
               sthigh=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
               stlow=iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0);
               }
            if (stlow<d_low) d_low=stlow;
            if (sthigh>d_high) d_high=sthigh;
            d_close=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
           }
         else
           {
            //---- no, there is new bar
            d_volume+=iVolume(c_symbol_1,0,1)+iVolume(c_symbol_2,0,1)-last_volume;
            if(iOpen(c_symbol_1,0,1)/iOpen(c_symbol_2,0,1)>iClose(c_symbol_1,0,1)/iClose(c_symbol_2,0,1))
               {
               sthigh=iOpen(c_symbol_1,0,1)/iOpen(c_symbol_2,0,1);
               stlow=iClose(c_symbol_1,0,1)/iClose(c_symbol_2,0,1);
               }
            else
               {
               sthigh=iClose(c_symbol_1,0,1)/iClose(c_symbol_2,0,1);
               stlow=iOpen(c_symbol_1,0,1)/iOpen(c_symbol_2,0,1);
               }
            if (stlow<d_low) d_low=stlow;
            if (sthigh>d_high) d_high=sthigh;
            //---- write previous bar remains
            FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
            FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
            last_fpos=FileTell(ExtHandle);
            //----
            i_time=time0/periodseconds;
            i_time*=periodseconds;
            d_open=iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0);
            if(iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0)>iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0))
               {
               d_high=iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0);
               d_low=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
               }
            else
               {
               d_high=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
               d_low=iOpen(c_symbol_1,0,0)/iOpen(c_symbol_2,0,0);
               }
            d_close=iClose(c_symbol_1,0,0)/iClose(c_symbol_2,0,0);
            d_volume=iVolume(c_symbol_1,0,0)+iVolume(c_symbol_2,0,0);
            last_volume=d_volume;
           }
         //----
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
         FileFlush(ExtHandle);
         //----
         if(hwnd==0)
           {
            hwnd=WindowHandle(Symbol(),i_period);
            if(hwnd!=0) Print("Chart window detected");
           }
         //---- refresh window not frequently than 1 time in 2 seconds
         if(hwnd!=0 && cur_time-last_time>=2)
           {
            PostMessageA(hwnd,WM_COMMAND,33324,0);
            last_time=cur_time;
           }
        }
      Sleep(50); 
     }      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit()
  {
   if(ExtHandle>=0) { FileClose(ExtHandle); ExtHandle=-1; }
  }
//+------------------------------------------------------------------+